Index: Makefile
===================================================================
--- Makefile	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ Makefile	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -10,5 +10,5 @@
 
 # Program variables
-objects = account.o bitlbee.o commands.o crypting.o help.o ini.o irc.o nick.o query.o set.o storage.o storage_text.o url.o user.o util.o
+objects = account.o bitlbee.o crypting.o help.o ini.o ipc.o irc.o irc_commands.o nick.o query.o root_commands.o set.o storage.o storage_text.o url.o user.o util.o
 subdirs = protocols
 
Index: bitlbee.c
===================================================================
--- bitlbee.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ bitlbee.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -29,44 +29,10 @@
 #include "protocols/nogaim.h"
 #include "help.h"
+#include "ipc.h"
 #include <signal.h>
 #include <stdio.h>
 #include <errno.h>
 
-gboolean bitlbee_io_new_client( GIOChannel *source, GIOCondition condition, gpointer data )
-{
-	size_t size = sizeof( struct sockaddr_in );
-	struct sockaddr_in conn_info;
-	int new_socket = accept( global.listen_socket, (struct sockaddr *) &conn_info, &size );
-	pid_t client_pid = 0;
-	
-	if( global.conf->runmode == RUNMODE_FORKDAEMON )
-		client_pid = fork();
-	
-	if( client_pid == 0 )
-	{
-		log_message( LOGLVL_INFO, "Creating new connection with fd %d.", new_socket );
-		irc_new( new_socket );
-		
-		if( global.conf->runmode == RUNMODE_FORKDAEMON )
-		{
-			/* Close the listening socket, we're a client. */
-			close( global.listen_socket );
-			g_source_remove( global.listen_watch_source_id );
-		}
-	}
-	else
-	{
-		/* We don't need this one, only the client does. */
-		close( new_socket );
-		
-		/* Or maybe we didn't even get a child process... */
-		if( client_pid == -1 )
-			log_message( LOGLVL_ERROR, "Failed to fork() subprocess for client: %s", strerror( errno ) );
-	}
-	
-	return TRUE;
-}
- 
-
+gboolean bitlbee_io_new_client( GIOChannel *source, GIOCondition condition, gpointer data );
 
 int bitlbee_daemon_init()
@@ -79,4 +45,5 @@
 	int i;
 	GIOChannel *ch;
+	FILE *fp;
 	
 	log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
@@ -89,4 +56,8 @@
 		return( -1 );
 	}
+	
+	/* TIME_WAIT (?) sucks.. */
+	i = 1;
+	setsockopt( global.listen_socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof( i ) );
 	
 #ifdef IPV6
@@ -134,10 +105,31 @@
 		else if( i != 0 ) 
 			exit( 0 );
-		close( 0 );
-		close( 1 );
-		close( 2 );
+		
 		chdir( "/" );
+		
+		/* Sometimes std* are already closed (for example when we're in a RESTARTed
+		   BitlBee process. So let's only close TTY-fds. */
+		if( isatty( 0 ) ) close( 0 );
+		if( isatty( 0 ) ) close( 1 );
+		if( isatty( 0 ) ) close( 2 );
 	}
 #endif
+	
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+		ipc_master_load_state();
+
+	if( global.conf->runmode == RUNMODE_DAEMON || 
+		global.conf->runmode == RUNMODE_FORKDAEMON )
+		ipc_master_listen_socket();
+	
+	if( ( fp = fopen( global.conf->pidfile, "w" ) ) )
+	{
+		fprintf( fp, "%d\n", (int) getpid() );
+		fclose( fp );
+	}
+	else
+	{
+		log_message( LOGLVL_WARNING, "Warning: Couldn't write PID to `%s'", global.conf->pidfile );
+	}
 	
 	return( 0 );
@@ -160,5 +152,5 @@
 	if( condition & G_IO_ERR || condition & G_IO_HUP )
 	{
-		irc_free( irc );
+		irc_abort( irc, 1, "Read error" );
 		return FALSE;
 	}
@@ -167,5 +159,5 @@
 	if( st == 0 )
 	{
-		irc_free( irc );
+		irc_abort( irc, 1, "Connection reset by peer" );
 		return FALSE;
 	}
@@ -178,5 +170,5 @@
 		else
 		{
-			irc_free( irc );
+			irc_abort( irc, 1, "Read error: %s", strerror( errno ) );
 			return FALSE;
 		}
@@ -194,8 +186,10 @@
 	}
 	
-	if( !irc_process( irc ) )
-	{
-		log_message( LOGLVL_INFO, "Destroying connection with fd %d.", irc->fd );
-		irc_free( irc );
+	irc_process( irc );
+	
+	/* Normally, irc_process() shouldn't call irc_free() but irc_abort(). Just in case: */
+	if( !g_slist_find( irc_connection_list, irc ) )
+	{
+		log_message( LOGLVL_WARNING, "Abnormal termination of connection with fd %d.", irc->fd );
 		return FALSE;
 	} 
@@ -204,6 +198,5 @@
 	if( irc->readbuffer && ( strlen( irc->readbuffer ) > 1024 ) )
 	{
-		log_message( LOGLVL_ERROR, "Maximum line length exceeded." );
-		irc_free( irc );
+		irc_abort( irc, 0, "Maximum line length exceeded" );
 		return FALSE;
 	}
@@ -224,15 +217,12 @@
 	st = write( irc->fd, irc->sendbuffer, size );
 	
-	if( st <= 0 )
-	{
-		if( sockerr_again() )
-		{
-			return TRUE;
-		}
-		else
-		{
-			irc_free( irc );
-			return FALSE;
-		}
+	if( st == 0 || ( st < 0 && !sockerr_again() ) )
+	{
+		irc_abort( irc, 1, "Write error: %s", strerror( errno ) );
+		return FALSE;
+	}
+	else if( st < 0 ) /* && sockerr_again() */
+	{
+		return TRUE;
 	}
 	
@@ -241,6 +231,9 @@
 		g_free( irc->sendbuffer );
 		irc->sendbuffer = NULL;
-		
 		irc->w_watch_source_id = 0;
+		
+		if( irc->status == USTATUS_SHUTDOWN )
+			irc_free( irc );
+		
 		return( FALSE );
 	}
@@ -255,4 +248,77 @@
 }
 
+gboolean bitlbee_io_new_client( GIOChannel *source, GIOCondition condition, gpointer data )
+{
+	size_t size = sizeof( struct sockaddr_in );
+	struct sockaddr_in conn_info;
+	int new_socket = accept( global.listen_socket, (struct sockaddr *) &conn_info, &size );
+	pid_t client_pid = 0;
+	
+	if( new_socket == -1 )
+	{
+		log_message( LOGLVL_WARNING, "Could not accept new connection: %s", strerror( errno ) );
+		return TRUE;
+	}
+	
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		int fds[2];
+		
+		if( socketpair( AF_UNIX, SOCK_STREAM, 0, fds ) == -1 )
+		{
+			log_message( LOGLVL_WARNING, "Could not create IPC socket for client: %s", strerror( errno ) );
+			fds[0] = fds[1] = -1;
+		}
+		
+		sock_make_nonblocking( fds[0] );
+		sock_make_nonblocking( fds[1] );
+		
+		client_pid = fork();
+		
+		if( client_pid > 0 && fds[0] != -1 )
+		{
+			struct bitlbee_child *child;
+			
+			child = g_new0( struct bitlbee_child, 1 );
+			child->pid = client_pid;
+			child->ipc_fd = fds[0];
+			child->ipc_inpa = gaim_input_add( child->ipc_fd, GAIM_INPUT_READ, ipc_master_read, child );
+			child_list = g_slist_append( child_list, child );
+			
+			log_message( LOGLVL_INFO, "Creating new subprocess with pid %d.", client_pid );
+			
+			/* Close some things we don't need in the parent process. */
+			close( new_socket );
+			close( fds[1] );
+		}
+		else if( client_pid == 0 )
+		{
+			irc_t *irc;
+			
+			/* Close the listening socket, we're a client. */
+			close( global.listen_socket );
+			g_source_remove( global.listen_watch_source_id );
+			
+			/* Make the connection. */
+			irc = irc_new( new_socket );
+			
+			/* We can store the IPC fd there now. */
+			global.listen_socket = fds[1];
+			global.listen_watch_source_id = gaim_input_add( fds[1], GAIM_INPUT_READ, ipc_child_read, irc );
+			
+			close( fds[0] );
+			
+			ipc_master_free_all();
+		}
+	}
+	else
+	{
+		log_message( LOGLVL_INFO, "Creating new connection with fd %d.", new_socket );
+		irc_new( new_socket );
+	}
+	
+	return TRUE;
+}
+
 void bitlbee_shutdown( gpointer data )
 {
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ bitlbee.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -109,5 +109,6 @@
 #include "sock.h"
 
-typedef struct global_t {
+typedef struct global {
+	/* In forked mode, child processes store the fd of the IPC socket here. */
 	int listen_socket;
 	gint listen_watch_source_id;
@@ -117,4 +118,5 @@
 	char *helpfile;
 	GMainLoop *loop;
+	int restart;
 } global_t;
 
@@ -125,6 +127,6 @@
 gboolean bitlbee_io_current_client_write( GIOChannel *source, GIOCondition condition, gpointer data );
 
-int root_command_string( irc_t *irc, user_t *u, char *command, int flags );
-int root_command( irc_t *irc, char *command[] );
+void root_command_string( irc_t *irc, user_t *u, char *command, int flags );
+void root_command( irc_t *irc, char *command[] );
 void bitlbee_shutdown( gpointer data );
 double gettime( void );
Index: commands.h
===================================================================
--- commands.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ commands.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -29,32 +29,20 @@
 #include "bitlbee.h"
 
-typedef struct command_t
+typedef struct command
 {
 	char *command;
 	int required_parameters;
-	int (*execute)(irc_t *, char **args);
+	void (*execute)(irc_t *, char **args);
+	int flags;
 } command_t;
-
-int cmd_account( irc_t *irc, char **cmd );
-int cmd_help( irc_t *irc, char **args);
-int cmd_info( irc_t *irc, char **args);
-int cmd_add( irc_t *irc, char **args) ;
-int cmd_rename( irc_t *irc, char **args );
-int cmd_remove( irc_t *irc, char **args );
-int cmd_block( irc_t *irc, char **args );
-int cmd_allow( irc_t *irc, char **args );
-int cmd_save( irc_t *irc, char **args );
-int cmd_set( irc_t *irc, char **args );
-int cmd_yesno( irc_t *irc, char **args );
-int cmd_identify( irc_t *irc, char **args );
-int cmd_register( irc_t *irc, char **args );
-int cmd_drop( irc_t *irc, char **args );
-int cmd_blist( irc_t *irc, char **cmd );
-int cmd_nick( irc_t *irc, char **cmd );
-int cmd_qlist( irc_t *irc, char **cmd );
-int cmd_import_buddies( irc_t *irc, char **cmd );
-int cmd_dump( irc_t *irc, char **cmd );
 
 extern const command_t commands[];
 
+#define IRC_CMD_PRE_LOGIN	1
+#define IRC_CMD_LOGGED_IN	2
+#define IRC_CMD_OPER_ONLY	4
+#define IRC_CMD_TO_MASTER	8
+
+#define IPC_CMD_TO_CHILDREN	1
+
 #endif
Index: conf.c
===================================================================
--- conf.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ conf.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -32,4 +32,5 @@
 #include "ini.h"
 #include "url.h"
+#include "ipc.h"
 
 #include "protocols/proxy.h"
@@ -61,7 +62,9 @@
 	conf->configdir = g_strdup( CONFIG );
 	conf->plugindir = g_strdup( PLUGINDIR );
+	conf->pidfile = g_strdup( "/var/run/bitlbee.pid" );
 	conf->motdfile = g_strdup( ETCDIR "/motd.txt" );
 	conf->ping_interval = 180;
 	conf->ping_timeout = 300;
+	proxytype = 0;
 	
 	i = conf_loadini( conf, CONF_FILE );
@@ -76,5 +79,6 @@
 	}
 	
-	while( ( opt = getopt( argc, argv, "i:p:nvIDFc:d:h" ) ) >= 0 )
+	while( argc > 0 && ( opt = getopt( argc, argv, "i:p:P:nvIDFc:d:hR:" ) ) >= 0 )
+	/*     ^^^^ Just to make sure we skip this step from the REHASH handler. */
 	{
 		if( opt == 'i' )
@@ -91,14 +95,19 @@
 			conf->port = i;
 		}
+		else if( opt == 'p' )
+		{
+			g_free( conf->pidfile );
+			conf->pidfile = g_strdup( optarg );
+		}
 		else if( opt == 'n' )
-			conf->nofork=1;
+			conf->nofork = 1;
 		else if( opt == 'v' )
-			conf->verbose=1;
+			conf->verbose = 1;
 		else if( opt == 'I' )
-			conf->runmode=RUNMODE_INETD;
+			conf->runmode = RUNMODE_INETD;
 		else if( opt == 'D' )
-			conf->runmode=RUNMODE_DAEMON;
+			conf->runmode = RUNMODE_DAEMON;
 		else if( opt == 'F' )
-			conf->runmode=RUNMODE_FORKDAEMON;
+			conf->runmode = RUNMODE_FORKDAEMON;
 		else if( opt == 'c' )
 		{
@@ -108,4 +117,8 @@
 				CONF_FILE = g_strdup( optarg );
 				g_free( conf );
+				/* Re-evaluate arguments. Don't use this option twice, 
+				   you'll end up in an infinite loop! Hope this trick
+				   works with all libcs BTW.. */
+				optind = 1;
 				return( conf_load( argc, argv ) );
 			}
@@ -126,4 +139,5 @@
 			        "  -D  Daemon mode. (Still EXPERIMENTAL!)\n"
 			        "  -F  Forking daemon. (one process per client)\n"
+			        "  -P  Specify PID-file (not for inetd mode)\n"
 			        "  -i  Specify the interface (by IP address) to listen on.\n"
 			        "      (Default: 0.0.0.0 (any interface))\n"
@@ -136,4 +150,12 @@
 			return( NULL );
 		}
+		else if( opt == 'R' )
+		{
+			/* We can't load the statefile yet (and should make very sure we do this
+			   only once), so set the filename here and load the state information
+			   when initializing ForkDaemon. (This option only makes sense in that
+			   mode anyway!) */
+			ipc_master_set_statefile( optarg );
+		}
 	}
 	
@@ -169,4 +191,9 @@
 				else
 					conf->runmode = RUNMODE_INETD;
+			}
+			else if( g_strcasecmp( ini->key, "pidfile" ) == 0 )
+			{
+				g_free( conf->pidfile );
+				conf->pidfile = g_strdup( ini->value );
 			}
 			else if( g_strcasecmp( ini->key, "daemoninterface" ) == 0 )
Index: conf.h
===================================================================
--- conf.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ conf.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -43,4 +43,5 @@
 	char *configdir;
 	char *plugindir;
+	char *pidfile;
 	char *motdfile;
 	char *primary_storage;
Index: doc/README
===================================================================
--- doc/README	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ doc/README	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -50,5 +50,5 @@
 
 These days, MSN Messenger clients have to connect to the MS Passport servers
-through HTTPS. BitlBee can use serveral SSL libraries for this: GnuTLS, NSS
+through HTTPS. BitlBee can use several SSL libraries for this: GnuTLS, NSS
 (which comes with Mozilla) and OpenSSL. OpenSSL is not GPL-compatible in some
 situations, so using GnuTLS or NSS is preferred. However, especially on *BSD,
Index: ipc.c
===================================================================
--- ipc.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
+++ ipc.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -0,0 +1,576 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2006 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* IPC - communication between BitlBee processes                        */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include "bitlbee.h"
+#include "ipc.h"
+#include "commands.h"
+#ifndef _WIN32
+#include <sys/un.h>
+#endif
+
+GSList *child_list = NULL;
+static char *statefile = NULL;
+
+static void ipc_master_cmd_client( irc_t *data, char **cmd )
+{
+	/* Normally data points at an irc_t block, but for the IPC master
+	   this is different. We think this scary cast is better than
+	   creating a new command_t structure, just to make the compiler
+	   happy. */
+	struct bitlbee_child *child = (void*) data;
+	
+	if( child && cmd[1] )
+	{
+		child->host = g_strdup( cmd[1] );
+		child->nick = g_strdup( cmd[2] );
+		child->realname = g_strdup( cmd[3] );
+	}
+	
+	if( g_strcasecmp( cmd[0], "CLIENT" ) == 0 )
+		ipc_to_children_str( "OPERMSG :Client connecting (PID=%d): %s@%s (%s)\r\n",
+		                     child ? child->pid : -1, cmd[2], cmd[1], cmd[3] );
+}
+
+static void ipc_master_cmd_die( irc_t *data, char **cmd )
+{
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+		ipc_to_children_str( "DIE\r\n" );
+	
+	bitlbee_shutdown( NULL );
+}
+
+void ipc_master_cmd_rehash( irc_t *data, char **cmd )
+{
+	runmode_t oldmode;
+	
+	oldmode = global.conf->runmode;
+	
+	g_free( global.conf );
+	global.conf = conf_load( 0, NULL );
+	
+	if( global.conf->runmode != oldmode )
+	{
+		log_message( LOGLVL_WARNING, "Can't change RunMode setting at runtime, restoring original setting" );
+		global.conf->runmode = oldmode;
+	}
+	
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+		ipc_to_children( cmd );
+}
+
+void ipc_master_cmd_restart( irc_t *data, char **cmd )
+{
+	struct bitlbee_child *child = (void*) data;
+	
+	if( global.conf->runmode != RUNMODE_FORKDAEMON )
+	{
+		/* Tell child that this is unsupported. */
+		return;
+	}
+	
+	global.restart = -1;
+	bitlbee_shutdown( NULL );
+}
+
+static const command_t ipc_master_commands[] = {
+	{ "client",     3, ipc_master_cmd_client,     0 },
+	{ "hello",      0, ipc_master_cmd_client,     0 },
+	{ "die",        0, ipc_master_cmd_die,        0 },
+	{ "wallops",    1, NULL,                      IPC_CMD_TO_CHILDREN },
+	{ "lilo",       1, NULL,                      IPC_CMD_TO_CHILDREN },
+	{ "opermsg",    1, NULL,                      IPC_CMD_TO_CHILDREN },
+	{ "rehash",     0, ipc_master_cmd_rehash,     0 },
+	{ "kill",       2, NULL,                      IPC_CMD_TO_CHILDREN },
+	{ "restart",    0, ipc_master_cmd_restart,    0 },
+	{ NULL }
+};
+
+
+static void ipc_child_cmd_die( irc_t *irc, char **cmd )
+{
+	irc_abort( irc, 0, "Shutdown requested by operator" );
+}
+
+static void ipc_child_cmd_wallops( irc_t *irc, char **cmd )
+{
+	if( irc->status < USTATUS_LOGGED_IN )
+		return;
+	
+	if( strchr( irc->umode, 'w' ) )
+		irc_write( irc, ":%s WALLOPS :%s", irc->myhost, cmd[1] );
+}
+
+static void ipc_child_cmd_lilo( irc_t *irc, char **cmd )
+{
+	if( irc->status < USTATUS_LOGGED_IN )
+		return;
+	
+	if( strchr( irc->umode, 's' ) )
+		irc_write( irc, ":%s NOTICE %s :%s", irc->myhost, irc->nick, cmd[1] );
+}
+
+static void ipc_child_cmd_opermsg( irc_t *irc, char **cmd )
+{
+	if( irc->status < USTATUS_LOGGED_IN )
+		return;
+	
+	if( strchr( irc->umode, 'o' ) )
+		irc_write( irc, ":%s NOTICE %s :*** OperMsg *** %s", irc->myhost, irc->nick, cmd[1] );
+}
+
+static void ipc_child_cmd_rehash( irc_t *irc, char **cmd )
+{
+	runmode_t oldmode;
+	
+	oldmode = global.conf->runmode;
+	
+	g_free( global.conf );
+	global.conf = conf_load( 0, NULL );
+	
+	global.conf->runmode = oldmode;
+}
+
+static void ipc_child_cmd_kill( irc_t *irc, char **cmd )
+{
+	if( irc->status < USTATUS_LOGGED_IN )
+		return;
+	
+	if( nick_cmp( cmd[1], irc->nick ) != 0 )
+		return;		/* It's not for us. */
+	
+	irc_write( irc, ":%s!%s@%s KILL %s :%s", irc->mynick, irc->mynick, irc->myhost, irc->nick, cmd[2] );
+	irc_abort( irc, 0, "Killed by operator: %s", cmd[2] );
+}
+
+static void ipc_child_cmd_hello( irc_t *irc, char **cmd )
+{
+	if( irc->status < USTATUS_LOGGED_IN )
+		ipc_to_master_str( "HELLO\r\n" );
+	else
+		ipc_to_master_str( "HELLO %s %s :%s\r\n", irc->host, irc->nick, irc->realname );
+}
+
+static const command_t ipc_child_commands[] = {
+	{ "die",        0, ipc_child_cmd_die,         0 },
+	{ "wallops",    1, ipc_child_cmd_wallops,     0 },
+	{ "lilo",       1, ipc_child_cmd_lilo,        0 },
+	{ "opermsg",    1, ipc_child_cmd_opermsg,     0 },
+	{ "rehash",     0, ipc_child_cmd_rehash,      0 },
+	{ "kill",       2, ipc_child_cmd_kill,        0 },
+	{ "hello",      0, ipc_child_cmd_hello,       0 },
+	{ NULL }
+};
+
+
+static void ipc_command_exec( void *data, char **cmd, const command_t *commands )
+{
+	int i, j;
+	
+	if( !cmd[0] )
+		return;
+	
+	for( i = 0; commands[i].command; i ++ )
+		if( g_strcasecmp( commands[i].command, cmd[0] ) == 0 )
+		{
+			/* There is no typo in this line: */
+			for( j = 1; cmd[j]; j ++ ); j --;
+			
+			if( j < commands[i].required_parameters )
+				break;
+			
+			if( commands[i].flags & IPC_CMD_TO_CHILDREN )
+				ipc_to_children( cmd );
+			else
+				commands[i].execute( data, cmd );
+			
+			break;
+		}
+}
+
+static char *ipc_readline( int fd )
+{
+	char *buf, *eol;
+	int size;
+	
+	buf = g_new0( char, 513 );
+	
+	/* Because this is internal communication, it should be pretty safe
+	   to just peek at the message, find its length (by searching for the
+	   end-of-line) and then just read that message. With internal
+	   sockets and limites message length, messages should always be
+	   complete. Saves us quite a lot of code and buffering. */
+	size = recv( fd, buf, 512, MSG_PEEK );
+	if( size == 0 || ( size < 0 && !sockerr_again() ) )
+		return NULL;
+	else if( size < 0 ) /* && sockerr_again() */
+		return( g_strdup( "" ) );
+	else
+		buf[size] = 0;
+	
+	eol = strstr( buf, "\r\n" );
+	if( eol == NULL )
+		return NULL;
+	else
+		size = eol - buf + 2;
+	
+	g_free( buf );
+	buf = g_new0( char, size + 1 );
+	
+	if( recv( fd, buf, size, 0 ) != size )
+		return NULL;
+	else
+		buf[size-2] = 0;
+	
+	return buf;
+}
+
+void ipc_master_read( gpointer data, gint source, GaimInputCondition cond )
+{
+	char *buf, **cmd;
+	
+	if( ( buf = ipc_readline( source ) ) )
+	{
+		cmd = irc_parse_line( buf );
+		if( cmd )
+			ipc_command_exec( data, cmd, ipc_master_commands );
+	}
+	else
+	{
+		GSList *l;
+		struct bitlbee_child *c;
+		
+		for( l = child_list; l; l = l->next )
+		{
+			c = l->data;
+			if( c->ipc_fd == source )
+			{
+				ipc_master_free_one( c );
+				child_list = g_slist_remove( child_list, c );
+				break;
+			}
+		}
+	}
+}
+
+void ipc_child_read( gpointer data, gint source, GaimInputCondition cond )
+{
+	char *buf, **cmd;
+	
+	if( ( buf = ipc_readline( source ) ) )
+	{
+		cmd = irc_parse_line( buf );
+		if( cmd )
+			ipc_command_exec( data, cmd, ipc_child_commands );
+	}
+	else
+	{
+		gaim_input_remove( global.listen_watch_source_id );
+		close( global.listen_socket );
+		
+		global.listen_socket = -1;
+	}
+}
+
+void ipc_to_master( char **cmd )
+{
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		char *s = irc_build_line( cmd );
+		ipc_to_master_str( "%s", s );
+		g_free( s );
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		ipc_command_exec( NULL, cmd, ipc_master_commands );
+	}
+}
+
+void ipc_to_master_str( char *format, ... )
+{
+	char *msg_buf;
+	va_list params;
+
+	va_start( params, format );
+	msg_buf = g_strdup_vprintf( format, params );
+	va_end( params );
+	
+	if( strlen( msg_buf ) > 512 )
+	{
+		/* Don't send it, it's too long... */
+	}
+	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		write( global.listen_socket, msg_buf, strlen( msg_buf ) );
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		char **cmd, *s;
+		
+		if( ( s = strchr( msg_buf, '\r' ) ) )
+			*s = 0;
+		
+		cmd = irc_parse_line( msg_buf );
+		ipc_command_exec( NULL, cmd, ipc_master_commands );
+		g_free( cmd );
+	}
+	
+	g_free( msg_buf );
+}
+
+void ipc_to_children( char **cmd )
+{
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		char *msg_buf = irc_build_line( cmd );
+		ipc_to_children_str( "%s", msg_buf );
+		g_free( msg_buf );
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		GSList *l;
+		
+		for( l = irc_connection_list; l; l = l->next )
+			ipc_command_exec( l->data, cmd, ipc_child_commands );
+	}
+}
+
+void ipc_to_children_str( char *format, ... )
+{
+	char *msg_buf;
+	va_list params;
+
+	va_start( params, format );
+	msg_buf = g_strdup_vprintf( format, params );
+	va_end( params );
+	
+	if( strlen( msg_buf ) > 512 )
+	{
+		/* Don't send it, it's too long... */
+	}
+	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		int msg_len = strlen( msg_buf );
+		GSList *l;
+		
+		for( l = child_list; l; l = l->next )
+		{
+			struct bitlbee_child *c = l->data;
+			write( c->ipc_fd, msg_buf, msg_len );
+		}
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		char **cmd, *s;
+		
+		if( ( s = strchr( msg_buf, '\r' ) ) )
+			*s = 0;
+		
+		cmd = irc_parse_line( msg_buf );
+		ipc_to_children( cmd );
+		g_free( cmd );
+	}
+	
+	g_free( msg_buf );
+}
+
+void ipc_master_free_one( struct bitlbee_child *c )
+{
+	gaim_input_remove( c->ipc_inpa );
+	closesocket( c->ipc_fd );
+	
+	g_free( c->host );
+	g_free( c->nick );
+	g_free( c->realname );
+	g_free( c );
+}
+
+void ipc_master_free_all()
+{
+	GSList *l;
+	
+	for( l = child_list; l; l = l->next )
+		ipc_master_free_one( l->data );
+	
+	g_slist_free( child_list );
+	child_list = NULL;
+}
+
+char *ipc_master_save_state()
+{
+	char *fn = g_strdup( "/tmp/bee-restart.XXXXXX" );
+	int fd = mkstemp( fn );
+	GSList *l;
+	FILE *fp;
+	int i;
+	
+	if( fd == -1 )
+	{
+		log_message( LOGLVL_ERROR, "Could not create temporary file: %s", strerror( errno ) );
+		g_free( fn );
+		return NULL;
+	}
+	
+	/* This is more convenient now. */
+	fp = fdopen( fd, "w" );
+	
+	for( l = child_list, i = 0; l; l = l->next )
+		i ++;
+	
+	/* Number of client processes. */
+	fprintf( fp, "%d\n", i );
+	
+	for( l = child_list; l; l = l->next )
+		fprintf( fp, "%d %d\n", ((struct bitlbee_child*)l->data)->pid,
+		                        ((struct bitlbee_child*)l->data)->ipc_fd );
+	
+	if( fclose( fp ) == 0 )
+	{
+		return fn;
+	}
+	else
+	{
+		unlink( fn );
+		g_free( fn );
+		return NULL;
+	}
+}
+
+void ipc_master_set_statefile( char *fn )
+{
+	statefile = g_strdup( fn );
+}
+
+
+static gboolean new_ipc_client (GIOChannel *gio, GIOCondition cond, gpointer data)
+{
+	struct bitlbee_child *child = g_new0( struct bitlbee_child, 1 );
+	int serversock;
+
+	serversock = g_io_channel_unix_get_fd(gio);
+
+	child->ipc_fd = accept(serversock, NULL, 0);
+
+	if (child->ipc_fd == -1) {
+		log_message( LOGLVL_WARNING, "Unable to accept connection on UNIX domain socket: %s", strerror(errno) );
+		return TRUE;
+	}
+		
+	child->ipc_inpa = gaim_input_add( child->ipc_fd, GAIM_INPUT_READ, ipc_master_read, child );
+		
+	child_list = g_slist_append( child_list, child );
+
+	return TRUE;
+}
+
+#ifndef _WIN32
+int ipc_master_listen_socket()
+{
+	struct sockaddr_un un_addr;
+	int serversock;
+	GIOChannel *gio;
+
+	/* Clean up old socket files that were hanging around.. */
+	if (unlink(IPCSOCKET) == -1 && errno != ENOENT) {
+		log_message( LOGLVL_ERROR, "Could not remove old IPC socket at %s: %s", IPCSOCKET, strerror(errno) );
+		return 0;
+	}
+
+	un_addr.sun_family = AF_UNIX;
+	strcpy(un_addr.sun_path, IPCSOCKET);
+
+	serversock = socket(AF_UNIX, SOCK_STREAM, PF_UNIX);
+
+	if (serversock == -1) {
+		log_message( LOGLVL_WARNING, "Unable to create UNIX socket: %s", strerror(errno) );
+		return 0;
+	}
+
+	if (bind(serversock, &un_addr, sizeof(un_addr)) == -1) {
+		log_message( LOGLVL_WARNING, "Unable to bind UNIX socket to %s: %s", IPCSOCKET, strerror(errno) );
+		return 0;
+	}
+
+	if (listen(serversock, 5) == -1) {
+		log_message( LOGLVL_WARNING, "Unable to listen on UNIX socket: %s", strerror(errno) );
+		return 0;
+	}
+	
+	gio = g_io_channel_unix_new(serversock);
+	
+	if (gio == NULL) {
+		log_message( LOGLVL_WARNING, "Unable to create IO channel for unix socket" );
+		return 0;
+	}
+
+	g_io_add_watch(gio, G_IO_IN, new_ipc_client, NULL);
+	return 1;
+}
+#else
+	/* FIXME: Open named pipe \\.\BITLBEE */
+#endif
+
+int ipc_master_load_state()
+{
+	struct bitlbee_child *child;
+	FILE *fp;
+	int i, n;
+	
+	if( statefile == NULL )
+		return 0;
+	fp = fopen( statefile, "r" );
+	unlink( statefile );	/* Why do it later? :-) */
+	if( fp == NULL )
+		return 0;
+	
+	if( fscanf( fp, "%d", &n ) != 1 )
+	{
+		log_message( LOGLVL_WARNING, "Could not import state information for child processes." );
+		fclose( fp );
+		return 0;
+	}
+	
+	log_message( LOGLVL_INFO, "Importing information for %d child processes.", n );
+	for( i = 0; i < n; i ++ )
+	{
+		child = g_new0( struct bitlbee_child, 1 );
+		
+		if( fscanf( fp, "%d %d", &child->pid, &child->ipc_fd ) != 2 )
+		{
+			log_message( LOGLVL_WARNING, "Unexpected end of file: Only processed %d clients.", i );
+			g_free( child );
+			fclose( fp );
+			return 0;
+		}
+		child->ipc_inpa = gaim_input_add( child->ipc_fd, GAIM_INPUT_READ, ipc_master_read, child );
+		
+		child_list = g_slist_append( child_list, child );
+	}
+	
+	ipc_to_children_str( "HELLO\r\n" );
+	ipc_to_children_str( "OPERMSG :New BitlBee master process started (version " BITLBEE_VERSION ")\r\n" );
+	
+	return 1;
+}
Index: ipc.h
===================================================================
--- ipc.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
+++ ipc.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -0,0 +1,61 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* IPC - communication between BitlBee processes                        */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include "bitlbee.h"
+
+
+struct bitlbee_child
+{
+	pid_t pid;
+	int ipc_fd;
+	gint ipc_inpa;
+	
+	char *host;
+	char *nick;
+	char *realname;
+};
+
+
+void ipc_master_read( gpointer data, gint source, GaimInputCondition cond );
+void ipc_child_read( gpointer data, gint source, GaimInputCondition cond );
+
+void ipc_master_free_one( struct bitlbee_child *child );
+void ipc_master_free_all();
+
+void ipc_to_master( char **cmd );
+void ipc_to_master_str( char *format, ... );
+void ipc_to_children( char **cmd );
+void ipc_to_children_str( char *format, ... );
+
+/* We need this function in inetd mode, so let's just make it non-static. */
+void ipc_master_cmd_rehash( irc_t *data, char **cmd );
+
+char *ipc_master_save_state();
+void ipc_master_set_statefile( char *fn );
+int ipc_master_load_state();
+int ipc_master_listen_socket();
+
+extern GSList *child_list;
